# coding: utf-8

"""
    VulnCheck API

    Version 3 of the VulnCheck API

    The version of the OpenAPI document: 3.0
    Contact: support@vulncheck.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from vulncheck_sdk.models.advisory_bugzilla import AdvisoryBugzilla
from vulncheck_sdk.models.advisory_issued import AdvisoryIssued
from vulncheck_sdk.models.advisory_oval_cve import AdvisoryOvalCVE
from vulncheck_sdk.models.advisory_updated import AdvisoryUpdated
from typing import Optional, Set
from typing_extensions import Self

class AdvisoryAdvisoryDetails(BaseModel):
    """
    AdvisoryAdvisoryDetails
    """ # noqa: E501
    bugzilla: Optional[AdvisoryBugzilla] = None
    cve: Optional[AdvisoryOvalCVE] = None
    issued: Optional[AdvisoryIssued] = None
    severity: Optional[StrictStr] = None
    updated: Optional[AdvisoryUpdated] = None
    __properties: ClassVar[List[str]] = ["bugzilla", "cve", "issued", "severity", "updated"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AdvisoryAdvisoryDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of bugzilla
        if self.bugzilla:
            _dict['bugzilla'] = self.bugzilla.to_dict()
        # override the default output from pydantic by calling `to_dict()` of cve
        if self.cve:
            _dict['cve'] = self.cve.to_dict()
        # override the default output from pydantic by calling `to_dict()` of issued
        if self.issued:
            _dict['issued'] = self.issued.to_dict()
        # override the default output from pydantic by calling `to_dict()` of updated
        if self.updated:
            _dict['updated'] = self.updated.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AdvisoryAdvisoryDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "bugzilla": AdvisoryBugzilla.from_dict(obj["bugzilla"]) if obj.get("bugzilla") is not None else None,
            "cve": AdvisoryOvalCVE.from_dict(obj["cve"]) if obj.get("cve") is not None else None,
            "issued": AdvisoryIssued.from_dict(obj["issued"]) if obj.get("issued") is not None else None,
            "severity": obj.get("severity"),
            "updated": AdvisoryUpdated.from_dict(obj["updated"]) if obj.get("updated") is not None else None
        })
        return _obj


