# coding: utf-8

"""
    VulnCheck API

    Version 3 of the VulnCheck API

    The version of the OpenAPI document: 3.0
    Contact: support@vulncheck.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AdvisoryCycle(BaseModel):
    """
    AdvisoryCycle
    """ # noqa: E501
    codename: Optional[StrictStr] = None
    cycle: Optional[StrictStr] = None
    discontinued: Optional[Dict[str, Any]] = None
    eol: Optional[Dict[str, Any]] = None
    extended_support: Optional[Dict[str, Any]] = Field(default=None, alias="extendedSupport")
    latest: Optional[StrictStr] = None
    latest_release_date: Optional[StrictStr] = Field(default=None, alias="latestReleaseDate")
    link: Optional[StrictStr] = None
    lts: Optional[Dict[str, Any]] = None
    release_date: Optional[StrictStr] = Field(default=None, alias="releaseDate")
    release_label: Optional[StrictStr] = Field(default=None, alias="releaseLabel")
    support: Optional[Dict[str, Any]] = None
    __properties: ClassVar[List[str]] = ["codename", "cycle", "discontinued", "eol", "extendedSupport", "latest", "latestReleaseDate", "link", "lts", "releaseDate", "releaseLabel", "support"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AdvisoryCycle from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AdvisoryCycle from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "codename": obj.get("codename"),
            "cycle": obj.get("cycle"),
            "discontinued": obj.get("discontinued"),
            "eol": obj.get("eol"),
            "extendedSupport": obj.get("extendedSupport"),
            "latest": obj.get("latest"),
            "latestReleaseDate": obj.get("latestReleaseDate"),
            "link": obj.get("link"),
            "lts": obj.get("lts"),
            "releaseDate": obj.get("releaseDate"),
            "releaseLabel": obj.get("releaseLabel"),
            "support": obj.get("support")
        })
        return _obj


