# coding: utf-8

"""
    VulnCheck API

    Version 3 of the VulnCheck API

    The version of the OpenAPI document: 3.0
    Contact: support@vulncheck.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from vulncheck_sdk.models.advisory_award import AdvisoryAward
from vulncheck_sdk.models.advisory_curl_cwe import AdvisoryCurlCWE
from typing import Optional, Set
from typing_extensions import Self

class AdvisoryDBSpecific(BaseModel):
    """
    AdvisoryDBSpecific
    """ # noqa: E501
    cwe: Optional[AdvisoryCurlCWE] = Field(default=None, alias="CWE")
    award: Optional[AdvisoryAward] = None
    last_affected: Optional[StrictStr] = None
    package: Optional[StrictStr] = None
    severity: Optional[StrictStr] = None
    url: Optional[StrictStr] = None
    www: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["CWE", "award", "last_affected", "package", "severity", "url", "www"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AdvisoryDBSpecific from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of cwe
        if self.cwe:
            _dict['CWE'] = self.cwe.to_dict()
        # override the default output from pydantic by calling `to_dict()` of award
        if self.award:
            _dict['award'] = self.award.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AdvisoryDBSpecific from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "CWE": AdvisoryCurlCWE.from_dict(obj["CWE"]) if obj.get("CWE") is not None else None,
            "award": AdvisoryAward.from_dict(obj["award"]) if obj.get("award") is not None else None,
            "last_affected": obj.get("last_affected"),
            "package": obj.get("package"),
            "severity": obj.get("severity"),
            "url": obj.get("url"),
            "www": obj.get("www")
        })
        return _obj


