# coding: utf-8

"""
    VulnCheck API

    Version 3 of the VulnCheck API

    The version of the OpenAPI document: 3.0
    Contact: support@vulncheck.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from vulncheck_sdk.models.advisory_ref_url import AdvisoryRefURL
from typing import Optional, Set
from typing_extensions import Self

class AdvisoryScore(BaseModel):
    """
    AdvisoryScore
    """ # noqa: E501
    cve: Optional[StrictStr] = None
    in_kev: Optional[StrictBool] = Field(default=None, alias="inKEV")
    in_vckev: Optional[StrictBool] = Field(default=None, alias="inVCKEV")
    reference_urls: Optional[List[AdvisoryRefURL]] = None
    score: Optional[StrictInt] = None
    __properties: ClassVar[List[str]] = ["cve", "inKEV", "inVCKEV", "reference_urls", "score"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AdvisoryScore from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in reference_urls (list)
        _items = []
        if self.reference_urls:
            for _item_reference_urls in self.reference_urls:
                if _item_reference_urls:
                    _items.append(_item_reference_urls.to_dict())
            _dict['reference_urls'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AdvisoryScore from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "cve": obj.get("cve"),
            "inKEV": obj.get("inKEV"),
            "inVCKEV": obj.get("inVCKEV"),
            "reference_urls": [AdvisoryRefURL.from_dict(_item) for _item in obj["reference_urls"]] if obj.get("reference_urls") is not None else None,
            "score": obj.get("score")
        })
        return _obj


