# coding: utf-8

"""
    VulnCheck API

    Version 3 of the VulnCheck API

    The version of the OpenAPI document: 3.0
    Contact: support@vulncheck.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from vulncheck_sdk.models.purl_package_urljson import PurlPackageURLJSON
from typing import Optional, Set
from typing_extensions import Self

class V3controllersPurlResponseMetadata(BaseModel):
    """
    V3controllersPurlResponseMetadata
    """ # noqa: E501
    purl_struct: Optional[PurlPackageURLJSON] = Field(default=None, description="meta-data about the purl")
    timestamp: Optional[StrictStr] = Field(default=None, description="time of the transaction")
    total_documents: Optional[StrictInt] = Field(default=None, description="number of results found")
    __properties: ClassVar[List[str]] = ["purl_struct", "timestamp", "total_documents"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V3controllersPurlResponseMetadata from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of purl_struct
        if self.purl_struct:
            _dict['purl_struct'] = self.purl_struct.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V3controllersPurlResponseMetadata from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "purl_struct": PurlPackageURLJSON.from_dict(obj["purl_struct"]) if obj.get("purl_struct") is not None else None,
            "timestamp": obj.get("timestamp"),
            "total_documents": obj.get("total_documents")
        })
        return _obj


