# coding: utf-8

"""
    VulnCheck API

    Version 3 of the VulnCheck API

    The version of the OpenAPI document: 3.0
    Contact: support@vulncheck.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from vulncheck_sdk.models.advisory_reported_exploit import AdvisoryReportedExploit
from vulncheck_sdk.models.advisory_xdb import AdvisoryXDB
from typing import Optional, Set
from typing_extensions import Self

class AdvisoryVulnCheckKEV(BaseModel):
    """
    AdvisoryVulnCheckKEV
    """ # noqa: E501
    timestamp: Optional[StrictStr] = Field(default=None, alias="_timestamp")
    cisa_date_added: Optional[StrictStr] = None
    cve: Optional[List[StrictStr]] = None
    cwes: Optional[List[StrictStr]] = None
    date_added: Optional[StrictStr] = None
    due_date: Optional[StrictStr] = Field(default=None, alias="dueDate")
    known_ransomware_campaign_use: Optional[StrictStr] = Field(default=None, alias="knownRansomwareCampaignUse")
    product: Optional[StrictStr] = None
    required_action: Optional[StrictStr] = None
    short_description: Optional[StrictStr] = Field(default=None, alias="shortDescription")
    vendor_project: Optional[StrictStr] = Field(default=None, alias="vendorProject")
    vulncheck_reported_exploitation: Optional[List[AdvisoryReportedExploit]] = None
    vulncheck_xdb: Optional[List[AdvisoryXDB]] = None
    vulnerability_name: Optional[StrictStr] = Field(default=None, alias="vulnerabilityName")
    __properties: ClassVar[List[str]] = ["_timestamp", "cisa_date_added", "cve", "cwes", "date_added", "dueDate", "knownRansomwareCampaignUse", "product", "required_action", "shortDescription", "vendorProject", "vulncheck_reported_exploitation", "vulncheck_xdb", "vulnerabilityName"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AdvisoryVulnCheckKEV from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in vulncheck_reported_exploitation (list)
        _items = []
        if self.vulncheck_reported_exploitation:
            for _item_vulncheck_reported_exploitation in self.vulncheck_reported_exploitation:
                if _item_vulncheck_reported_exploitation:
                    _items.append(_item_vulncheck_reported_exploitation.to_dict())
            _dict['vulncheck_reported_exploitation'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in vulncheck_xdb (list)
        _items = []
        if self.vulncheck_xdb:
            for _item_vulncheck_xdb in self.vulncheck_xdb:
                if _item_vulncheck_xdb:
                    _items.append(_item_vulncheck_xdb.to_dict())
            _dict['vulncheck_xdb'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AdvisoryVulnCheckKEV from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_timestamp": obj.get("_timestamp"),
            "cisa_date_added": obj.get("cisa_date_added"),
            "cve": obj.get("cve"),
            "cwes": obj.get("cwes"),
            "date_added": obj.get("date_added"),
            "dueDate": obj.get("dueDate"),
            "knownRansomwareCampaignUse": obj.get("knownRansomwareCampaignUse"),
            "product": obj.get("product"),
            "required_action": obj.get("required_action"),
            "shortDescription": obj.get("shortDescription"),
            "vendorProject": obj.get("vendorProject"),
            "vulncheck_reported_exploitation": [AdvisoryReportedExploit.from_dict(_item) for _item in obj["vulncheck_reported_exploitation"]] if obj.get("vulncheck_reported_exploitation") is not None else None,
            "vulncheck_xdb": [AdvisoryXDB.from_dict(_item) for _item in obj["vulncheck_xdb"]] if obj.get("vulncheck_xdb") is not None else None,
            "vulnerabilityName": obj.get("vulnerabilityName")
        })
        return _obj


